<!-- sft -->
<template>

  <div style="position: relative">
    <el-collapse v-model="activeName" accordion ref="collapse" v-resize="resize" style="margin-bottom:20px">
      <el-collapse-item name="1">
        <template slot="title">
          <div class="title">开发流程</div>
        </template>
        <div class="instructions">
          <div class="instructionsList">
            <div class="item" v-for="(item, index) in instructionsList" :key="index">
              <div>
                <img class="img" :src="item.img" alt="" />

                <div class="itemTitle">
                  <span class="head-index">{{ index + 1 }} &nbsp;</span>{{ item.title }}
                </div>

                <div class="itemDescribe">{{ item.describe }}</div>
              </div>

              <i v-if="instructionsList.length!==index+1" class="el-icon-arrow-right" style="margin-left: 50px; font-size: 30px; font-weight: bolder;color:#b8babf"></i>
            </div>
          </div>
        </div>
      </el-collapse-item>
    </el-collapse>
    <div class="tableBox" :style="{ height: tableHeight }">
      <el-form ref="myDataSetPage" :model="myDataSetPage" label-width="75px" :size="defaultFormItemSize" label-position="right" @submit.native.prevent>
        <filter-box :item-width="350" @search="refresh()" @reset="onReset">
          <el-form-item label-width="0px">
            <el-button class="add" type="primary" icon="el-icon-plus" :size="defaultFormItemSize" @click="add()">创建训练任务</el-button>
          </el-form-item>
          <el-form-item label="任务名称" prop="formFilter.taskName" label-width="120px">
            <el-input class="filter-item" v-model="myDataSetPage.formFilter.taskName" :clearable="true" placeholder="任务名称" />
          </el-form-item>
        </filter-box>
      </el-form>

      <vxe-table border show-header-overflow show-overflow :row-config="{ isHover: true }" :data="myDataSetPage.tableData.impl.dataList" min-height="96">
        <vxe-column field="taskName" title="任务名称"></vxe-column>
        <vxe-column field="taskId" title="任务ID"></vxe-column>
        <vxe-column field="taskType" title="任务类型">
          <template slot-scope="scope">
            {{ModelType.getValue(scope.row.taskType)  }}
          </template>

        </vxe-column>
        <vxe-column field="runCount" title="运行数量"></vxe-column>
        <vxe-column field="taskDescribe" title="任务描述"></vxe-column>
        <vxe-column field="createUserId" title="创建人">
          <template slot-scope="scope">
            {{scope.row.createUserIdDictMap.name}}
          </template>
        </vxe-column>
        <vxe-column field="createTime" title="创建时间"></vxe-column>
        <vxe-column field="operation" title="操作">
          <template slot-scope="scope">

            <el-button type="text" :size="defaultFormItemSize" @click="particulars(scope.row)">详情</el-button>
            <el-button type="text" :size="defaultFormItemSize" @click="newRun(scope.row)">新建运行</el-button>
            <el-button type="text" :size="defaultFormItemSize" @click="del(scope.row)">删除</el-button>
            <!-- <el-button type="text" :size="defaultFormItemSize" @click="edit(scope.row)">编辑</el-button>
              <el-button type="text" :size="defaultFormItemSize" @click="del(scope.row)">删除</el-button> -->
          </template>
        </vxe-column>
      </vxe-table>
      <el-row slot="pagination" type="flex" justify="end" style="margin-top: 16px;width: 100%;">
        <el-pagination :total="myDataSetPage.tableData.impl.totalCount" :current-page="myDataSetPage.tableData.impl.currentPage" :page-size="myDataSetPage.tableData.impl.pageSize" :page-sizes="[10, 20, 50, 100]" layout="total, prev, pager, next, sizes" @current-change="myDataSetPage.tableData.impl.onCurrentPageChange" @size-change="myDataSetPage.tableData.impl.onPageSizeChange">
        </el-pagination>
      </el-row>
    </div>
  </div>
</template>
  
<script>
import { mapGetters } from 'vuex'
/* eslint-disable-next-line */
import { DropdownWidget, TableWidget, UploadWidget, ChartWidget } from '@/utils/widget.js'
import { TuningTask } from '@/api/gptController.js'
import editOrAdd from './dialog/editOrAdd'
import particulars from './particulars/index'
export default {
  data() {
    return {
      activeName: '1',
      collapseHeight: 0,
      instructionsList: [
        {
          title: '数据准备',
          describe: '确保已准备好大模型的训练数据，或前往 数据集管理  中标注数据',
          img: require('@/assets/img/sft-0.png')
        },
        {
          title: 'SFT',
          describe: '利用准备好的训练数据及平台提供的预训练大模型，训练自己的大模型。',
          img: require('@/assets/img/sft-1.png')
        },
        {
          title: '发布模型',
          describe: '完成SFT后，可以发布训练后的模型，或继续在RLHF训练过程对模型继续训练。',
          img: require('@/assets/img/sft-2.png')
        }
      ],
      myDataSetPage: {
        formFilter: {
          taskName: ''
        },

        tableData: {
          impl: new TableWidget(this.getwidgetData, true, true, false, undefined, false)
        }
      }
    }
  },

  components: {},

  computed: {
    ...mapGetters(['getMainContextHeight']),
    tableHeight() {
      return this.getMainContextHeight - this.collapseHeight - 55 + 'px'
    }
  },

  methods: {
    getwidgetData(params) {
      if (params == null) params = {}
      params = {
        ...params,
        // orderParam: [
        //   {
        //     asc: true,
        //     dateAggregateBy: '',
        //     fieldName: ''
        //   }
        // ],
        // pageParam: {
        //   pageNum: 0,
        //   pageSize: 0
        // },
        tuningTaskDtoFilter: { ...this.myDataSetPage.formFilter }
      }

      return new Promise((resolve, reject) => {
        TuningTask.list(this, params)
          .then((res) => {
            resolve({
              dataList: res.data.dataList,
              totalCount: res.data.totalCount
            })
          })
          .catch((e) => {
            reject(e)
          })
      })
    },
    newRun(item) {
      this.$dialog
        .show(
          '创建SFT任务',
          editOrAdd,
          {
            area: ['100%', '100%']
          },
          {
            isEdit: false,
            existingTask: true,
            item: {
              tuningTaskDto: {
                taskName: item.taskName,
                taskDescribe: item.taskDescribe,
                taskType: item.taskType,
                taskId: item.taskId
              }
            }
          }
        )
        .then((res) => {
          this.refresh()
        })
        .catch((e) => {})
    },
    particulars(item) {
      this.$dialog
        .show(
          '详情',
          particulars,
          {
            area: ['100%', '100%']
          },
          { tableItem: item }
        )
        .then((res) => {
          this.refresh()
        })
        .catch((e) => {})
    },
    add() {
      this.$dialog
        .show(
          '创建SFT任务',
          editOrAdd,
          {
            area: ['100%', '100%']
          },
          { isEdit: false, existingTask: false }
        )
        .then((res) => {
          this.refresh()
        })
        .catch((e) => {})
    },
    edit(item) {
      this.$dialog
        .show(
          '修改模版',
          editOrAdd,
          {
            area: ['100%', '100%']
          },
          { isEdit: true, item: item }
        )
        .then((res) => {
          this.refresh()
        })
        .catch((e) => {})
    },
    del(item) {
      this.$confirm('是否确认删除', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        let params = { taskId: item.taskId }
        TuningTask.delete(this, params)
          .then((res) => {
            this.$message.success('删除成功')
            this.refresh()
          })
          .catch((e) => {
            console.log(e)
          })
      })
    },
    refresh(reloadData = false) {
      if (reloadData) {
        this.myDataSetPage.tableData.impl.refreshTable(true, 1)
      } else {
        this.myDataSetPage.tableData.impl.refreshTable()
      }
    },
    onReset() {
      this.$refs.myDataSetPage.resetFields()
      this.refresh(true)
    },
    formInit() {
      this.refresh()
    },
    resize(e) {
      setTimeout(() => {
        this.collapseHeight = e?.height
      }, 300)
    }
  },
  mounted() {
    this.resize()
    this.formInit()
  }
}
</script>
  <style lang="scss" scoped>
@import '@/assets/style/element-variables.scss';
.instructions {
  background-color: white;
  width: 100%;
  padding: 0px 20px 20px 20px;
  height: 200px;

  .instructionsList {
    display: flex;
    flex-direction: row;
    justify-content: space-around;
    .item {
      display: flex;
      align-items: center;
    }
  }
  .title {
    color: $--color-text-primary;
    font-size: 16px;
    font-weight: 500;
    margin-bottom: 8px;
  }
  .describe {
    color: $--color-text-secondary;
    margin-bottom: 16px;
  }
  .itemTitle {
    color: $--color-text-primary;
    font-size: 16px;
    font-weight: 500;
    margin-bottom: 8px;
  }
  .head-index {
    font-size: 24px;
    color: #e8e9eb;
    line-height: 32px;
  }
  .itemDescribe {
    width: 170px;
    color: $--color-text-secondary;
  }
  .img {
    height: 72px;
    width: 140px;
  }
}
.tableBox {
  background-color: white;
  width: 100%;
  padding: 20px;
  overflow: auto;
  .add {
    margin-bottom: 20px;
  }
}
div /deep/ .el-collapse-item__content {
  padding-bottom: 0;
}
div /deep/ .el-collapse-item__header {
  padding-left: 20px;
}
</style>
